*
* SMS/QDOS lock package
* Jonathan Hudson 12/01/96
* No rights reserved 

	.text
	.globl _TestLock
	.globl _TestLock0	
	.globl _GetLock
	.globl _GetLock0	
	.globl _FreeLock
	.globl _FreeLock0	
	.globl _InitLock
	
_InitLock:	
	move.l	4(sp),a0
	move.l	#0,(a0)
	move.l  #0,4(a0)
	rts
*
*	TryLock(int n, LOCK *l)
*	TryLock0(LOCK *l)
*
*	returns  0 if get lock
*	returns -1 if fails	
*

_TestLock:
	movem.l	4(sp),d0/a0
	bra	t01
_TestLock0:
	move.l	4(sp),a0
	moveq	#0,d0
t01:
	bset.b	d0,4(a0)
	bne	t02
	moveq	#0,d0
	bra	t03
t02:
	moveq	#-1,d0
t03:	
	rts

_GetLock:
	movem.l	4(sp),d0/a0
	bra	g01
_GetLock0:
	move.l	4(sp),a0
	moveq	#0,d0
g01:
	bset.b	d0,4(a0)
	bne	g02
	rts

* we failed to get the lock, now we have to do some work :-(

g02:
	move.w	d3,-(sp)	; needed for mt.susjb
	movem.l	d0/d2/a0,-(sp)	; corrupted by next call
	moveq	#0,d0		; mt.inf
	trap	#1		; just want the job ID
	movem.l	(sp)+,d0/d2/a0	; our registers
	sub.w	#14,sp		; make room for list item
	move.l	sp,a1		; lock address
	move.w	d0,12(a1)	; lock number
	move.l	d1,8(a1)	; job id
	trap	#0		; atomic change of list
	move.l	a0,4(a1)	; lock address 
	move.l	(a0),(a1)	; next
	move.l	a1,(a0)		; list head
	andi.w	#$d8ff,sr	; user mode again
	move.w	#-1,d3		; wait time
	move.l	#0,a1		; no clear
g03:
	moveq	#8,d0		; mt.susjb (d1 is already job id)
	trap	#1		; sleep
	move.w	12(sp),d0	; lock number
	move.l	4(sp),a0	; lock address
	bset.b	d0,4(a0)	; try for lock
	bne	g03		; fails
	
* Free our node (other items may be in the list).

	move.l	sp,a1		; copy stack pointer
	trap	#0		; don't let the list move on us
g04:	
	cmp.l	(a0),a1		; is this us ?
	beq	g05		; yipee !!
	move.l	(a0),a0		; next 
	bra	g04
g05:
	move.l	(a1),(a0)	; remove from list
	andi.w	#$d8ff,sr	; user mode time again	
	add.w	#14,sp		; recover stack
	move.w	(sp)+,d3	; recover d3
	rts			; simple jim !

_FreeLock:
	movem.l	4(sp),d0/a0
	bra	u01

_FreeLock0:
	move.l	4(sp),a0
	moveq	#0,d0
u01:
	bclr.b	d0,4(a0)	; clear lock bit
	trap	#0
	move.l	(a0),d1		; any waiters (garcon !)
	bne	u03		; yes
u02:	
	andi.w	#$d8ff,sr	; user mode time again	
	rts
u03:
	move.l	d1,a1
	cmp.b	13(a1),d0	; our lock number ?
	beq	u04		; yes, so wake'm
	move.l	(a1),d1		; next item
	bne	u03		; continue
	bra	u02		; exit at end of list
u04:	
	move.l	8(a1),d1	; jobID of waiter
	moveq	#9,d0		; mt.reljb
	andi.w	#$d8ff,sr	; user mode
	trap	#1		; release waiting job
	rts
	end

