
    /*
     * Lock demo (c) jh '96 - No rights reserved
     * build as: qcc -I. -O -o testl testl.c lock.s jcall.s
     * for Linux/XTC68, SMS/QDOS as appropriate
     */


#include <stdio.h>
#include <stdlib.h>
#include <lock.h>
#include <qdos.h>
#include <unistd.h>

void (*_SigStart)(void) = NULL;
static LOCK lck;

void thread(int n)
{
    int l1;
    GetLock0(lck);
    l1 = TestLock(1, lck);
    printf("Thread %d got the lock 0", n);
    if(l1 == 0) 
    {
	puts(", also got lock 1");
    }
    else
    {
	puts(", exiting");
    }

    FreeLock0(lck);

    if(l1 == 0)
    {
	mt_susjb(-1, 150, NULL);
	printf("Thread %d giving up lock 1\n", n);	
	FreeLock(1, lck);
    }
}

extern jcall (void (*)( ), char *, int, int, int,...);

int main(int ac, char **av)
{
    InitLock(lck);
    
    GetLock0(lck);
    puts("Parent, locked 0");
    jcall(thread, "Thread1", 1, 1024, 1, 1);
    jcall(thread, "Thread2", 1, 1024, 1, 2);    

    /* Wait until a thread asks for the lock */

    while(LOCK_QUEUE(lck) == 0)
    {
	mt_susjb(-1, 2, NULL);
    }
    FreeLock0(lck);

    /* Now the threads will unblock */
    /* We block to make sure a thread gets lock 1 first */

    while(LOCK_QUEUE(lck))
    {
	mt_susjb(-1, 2, NULL);
    }

    /* The lock queues are empty, wait until the last lock is freed */
 
    GetLock(1, lck);
    fputs("main is exiting : ", stdout);
    
    return 0;
}
